iic: xiic_eeprom_example.c File Reference

| iic Xilinx SDK Drivers API Documentation

- Overview
- Data Structures
- APIs
- File List
- Examples

Functions
xiic_eeprom_example.c File Reference

## Overview

This file consists of a Interrupt mode design example which uses the Xilinx IIC device and XIic driver to exercise the EEPROM.

The XIic driver uses the complete FIFO functionality to transmit/receive data.

This example writes/reads from the lower 256 bytes of the IIC EEPROMS. Please refer to the datasheets of the IIC EEPROM's for details about the internal addressing and page size of these devices.

The XIic_MasterSend() API is used to transmit the data and XIic_MasterRecv() API is used to receive the data.

This example is tested on ML300/ML310/ML410/ML403/ML501/ML507/ML510/ML605/ SP601, SP605, KC705 , ZC702 and ZC706 Xilinx boards.

The ML310/ML510/ML410 boards have a on-board 64 Kb serial IIC EEPROM (Microchip 24LC64A). The WP pin of the IIC EEPROM is hardwired to ground on this board.

The ML300 board has an on-board 32 Kb serial IIC EEPROM(Microchip 24LC32A). The WP pin of the IIC EEPROM has to be connected to ground for this example. The WP is connected to pin Y3 of the FPGA.

The ML403 board has an on-board 4 Kb serial IIC EEPROM(Microchip 24LC04A). The WP pin of the IIC EEPROM is hardwired to ground on this board.

The ML501/ML505/ML507/ML605/SP601/SP605/KC705/ZC702/ZC706 boards have an on-board 8 Kb serial IIC EEPROM(STM M24C08). The WP pin of the IIC EEPROM is hardwired to ground on these boards.

The AddressType for ML300/ML310/ML410/ML510 boards should be u16 as the address pointer in the on board EEPROM is 2 bytes.

The AddressType for ML403/ML501/ML505/ML507/ML605/SP601/SP605/KC705/ZC702/ ZC706 boards should be u8 as the address pointer for the on board EEPROM is 1 byte.

The 7 bit IIC Slave address of the IIC EEPROM on the ML300/ML310/ML403/ML410/ ML501/ML505/ML507/ML510 boards is 0x50. The 7 bit IIC Slave address of the IIC EEPROM on the ML605/SP601/SP605/KC705 /ZC702/ZC706 boards is 0x54. Refer to the User Guide's of the respective boards for further information about the IIC slave address of IIC EEPROM's.

The define EEPROM_ADDRESS in this file needs to be changed depending on the board on which this example is to be run. This is the IIC address of the EEPROM.

The define IIC_MUX_ADDRESS in this file needs to be changed depending on the board on which this example is to be run. This is the IIC address of the the MUX.

The define IIC_MUX_ENABLE should be defined so that the IIC Mux initialization is done for the boards on the which the EEPROM is connected to an IIC Mux. The boards with a MUX are a KC705/ZC702/ZC706.

The define IIC_EEPROM_CHANNEL needs to be changed depending on the Channel number of EEPROM for IIC Mux. On KC705 it is 0x08 and ZC702 is 0x04. Please refer the User Guide's of the respective boards for further information about the Channel number to use EEPROM.

This code assumes that no Operating System is being used.

Note

None.

    MODIFICATION HISTORY:

    Ver   Who  Date  Changes

    1.00a mta  02/24/06 Created.
    1.00a mta  04/05/07 Added support for microblaze.
    2.00a ktn  11/17/09 Updated to use the HAL APIs and replaced call to
                  XIic_Initialize API with XIic_LookupConfig and
                  XIic_CfgInitialize.
    2.01a ktn  03/17/10 Updated the information about the EEPROM's used on
                  ML605/SP601/SP605 boards. Updated the example so that it
                  can be used to access the entire IIC EEPROM for devices
                  like M24C04/M24C08 that use LSB bits of the IIC device
                  select code (IIC slave address) to specify the higher
                  address bits of the EEPROM internal address.
    2.02a bss  01/30/13 Updated for using the GIC in case of Zynq
    2.06a bss  02/14/13 Added MuxInit API to support Zynq and KC705 boards and
                  modified to use ScuGic in case of Zynq CR# 683509
    3.4   ms   01/23/17 Added xil_printf statement in main function to
                        ensure that "Successfully ran" and "Failed" strings
                        are available in all examples. This is a fix for
                        CR-965028.

## Functions
int | IicEepromExample ()
| This function writes, reads, and verifies the data to the IIC EEPROM. More...
int | EepromWriteData (u16 ByteCount)
| This function writes a buffer of data to the IIC serial EEPROM. More...
int | EepromReadData (u8 *BufferPtr, u16 ByteCount)
| This function reads data from the IIC serial EEPROM into a specified buffer. More...
int | main (void)
| Main function to call the High level EEPROM example. More...

## Function Documentation

int EepromReadData | ( | u8 * | BufferPtr,
|  | u16 | ByteCount
| ) |  |

This function reads data from the IIC serial EEPROM into a specified buffer.

Parameters

  BufferPtr | contains the address of the data buffer to be filled.
  ByteCount | contains the number of bytes in the buffer to be read.

Returns
  XST_SUCCESS if successful else XST_FAILURE.

Note
  None.

References EepromWriteData(), XIic_MasterRecv(), XIic_Start(), and XIic_Stop().

Referenced by IicEepromExample().

int EepromWriteData | ( | u16 | ByteCount | ) |

This function writes a buffer of data to the IIC serial EEPROM.

Parameters

  ByteCount | contains the number of bytes in the buffer to be written.

Returns
  XST_SUCCESS if successful else XST_FAILURE.

Note
  The Byte count should not exceed the page size of the EEPROM as noted by the constant PAGE_SIZE.

References XIic::Stats, XIicStats::TxErrors, XIic_MasterSend(), XIic_Start(), and XIic_Stop().

Referenced by EepromReadData(), and IicEepromExample().

int IicEepromExample | ( |  | ) |

This function writes, reads, and verifies the data to the IIC EEPROM.

It does the write as a single page write, performs a buffered read.

Parameters

  None. |

Returns
  XST_SUCCESS if successful else XST_FAILURE.

Note
  None.

References XIic_Config::BaseAddress, EepromReadData(), EepromWriteData(), XII_ADDR_TO_SEND_TYPE, XIic_CfgInitialize(), XIic_LookupConfig(), XIic_SetAddress(), XIic_SetRecvHandler(), XIic_SetSendHandler(), and XIic_SetStatusHandler().

Referenced by main().

int main | ( | void |  | ) |

Main function to call the High level EEPROM example.

Parameters

  None. |

Returns
  XST_SUCCESS if successful else XST_FAILURE.

Note
  None.

References IicEepromExample().